<template>
    <div class="heatmap">

        <div :key="ri" class="row" v-for="(m, ri) in matrix">
            <div :style='{fontSize: FS, height: Length}' class="label mx-1">
                {{vHeader[ri]}}
            </div>
            <div :class="Box" :key="ri*10000 + ii" :style="v.style" v-for="(v, ii) in m">
                {{v.value.toFixed(2)}}
            </div>
        </div>
        <div class="row">
            <div :class="Box"></div>
            <div :class="Box" :style='{fontSize: FS}' class="label my-1" v-for="s in hHeader">
                {{s}}
            </div>
        </div>
    </div>

</template>

<style lang='scss' scoped>



    .heatmap {
        display: flex;
        flex-direction: column;
        align-items: center;
        justify-content: center;
    }

    .box-base {
        display: flex;
        justify-content: center;
        align-items: center;
        transition: background-color 0.5s;

    }


    .label {
        @extend .box-base;
        color: grey;
        font-family: Raleway, sans-serif;
    }


    $xs: 35px;
    $md: 70px;
    $l: 120px;

    .xs-box {
        @extend .box-base;
        font-size: 14px;
        width: $xs;
        height: $xs;
    }

    .md-box {
        @extend .box-base;
        font-size: 18px;
        width: $md;
        height: $md;
    }

    .l-box {
        @extend .box-base;
        font-size: 25px;
        width: $l;
        height: $l;
    }


    .row {
        display: flex;
    }

</style>

<script lang='ts'>
    import {Component, Prop, Vue} from 'vue-property-decorator';


    type MValue = { style: { background: string }, value: number }


    @Component
    export default class HeatMap extends Vue {
        @Prop() matrix!: MValue[][]
        @Prop() vHeader!: string[];
        @Prop() hHeader!: string[];

        get FS(): string {
            if (this.$vuetify.breakpoint.xsOnly) {
                return '14px'
            } else if (this.$vuetify.breakpoint.mdAndDown) {
                return '18px'
            } else {
                return '25px'
            }
        }

        get Length(): string {
            if (this.$vuetify.breakpoint.xsOnly) {
                return '35px'
            } else if (this.$vuetify.breakpoint.mdAndDown) {
                return '70px'
            } else {
                return '120px'
            }
        }


        get Box() {
            if (this.$vuetify.breakpoint.xsOnly) {
                return ['xs-box']
            } else if (this.$vuetify.breakpoint.mdAndDown) {
                return ['md-box']
            } else {
                return ['l-box']
            }
        }

    }
</script>
